leetcode----127. Word Ladder

2024-01-12 01:48
文章标签 leetcode word 127 ladder

本文主要是介绍leetcode----127. Word Ladder,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

链接:

https://leetcode.com/problems/word-ladder/

大意:

给定一个单词beginWord以及单词endWord,还有一个词典wordList。要求找出从beginWord转换为endWord的最短序列长度,且每次转换候的单词都必须是wordList中单词,且每次转换只能是两个仅有一位(且是同一位置)不同的字符串进行转换。例子:

思路:

dfs回溯+剪枝。

从endWord往beginWord进行回溯,最终超时... 

请看zhazhad代码。

代码:(超时)

class Solution {int minCount = Integer.MAX_VALUE;int curCount = 1; // 初始为1public int ladderLength(String beginWord, String endWord, List<String> wordList) {if (!wordList.contains(endWord))return 0;// 一次转换即可 转换序列长度为2if (oneWordDifferent(beginWord, endWord))return 2;// 从endWord开始dfs逆推表演 将endWord的访问标志置为trueboolean[] visited = new boolean[wordList.size()];for (int i = 0; i < wordList.size(); i++) {if (wordList.get(i).equals(endWord)) {visited[i] = true;break;}}dfs(beginWord, endWord, wordList, visited);return minCount == Integer.MAX_VALUE ? 0 : minCount;}public void dfs(String beginWord, String curWord, List<String> wordList, boolean[] visited) {// System.out.println(beginWord + ":" + curWord + ":" + curCount);if (oneWordDifferent(beginWord, curWord)) {minCount = curCount + 1;return ;}curCount++;int idx = 0;// 剪枝while (curCount < minCount && idx < wordList.size()) {if (!visited[idx] && oneWordDifferent(curWord, wordList.get(idx))) {visited[idx] = true;dfs(beginWord, wordList.get(idx), wordList, visited);visited[idx] = false; // 回溯}idx++;}curCount--;}// 判断两个单词是否只有对应一位不同public boolean oneWordDifferent(String beginWord, String curWord) {int c = 0, idx = 0;while (idx < beginWord.length()) {if (beginWord.charAt(idx) != curWord.charAt(idx))c++;idx++;}return c == 1;}
}

结果:

超时。思考:也许得用BFS。。。

改进:

使用广度优先遍历算法解决。虽然通过了,但是效率好低啊(蠢哭...  急需大神代码安慰

class Solution {public int ladderLength(String beginWord, String endWord, List<String> wordList) {if (!wordList.contains(endWord))return 0;// 一次转换即可 转换序列长度为2if (oneWordDifferent(beginWord, endWord))return 2;boolean[] visited = new boolean[wordList.size()];int count = 1;for (int i = 0; i < wordList.size(); i++) {if (wordList.get(i).equals(endWord)) {visited[i] = true;break;}}List<String> curWords = new ArrayList<>();curWords.add(endWord);while (curWords.size() > 0) {List<String> tmp = new ArrayList<>();for (String s : curWords) {for (int i = 0; i < wordList.size(); i++) {if (!visited[i] && oneWordDifferent(s, wordList.get(i))) {tmp.add(wordList.get(i));visited[i] = true;// 快速判断if (wordList.get(i).equals(beginWord))return count + 1;if (oneWordDifferent(wordList.get(i), beginWord))return count + 2;}}}count += 1;curWords = tmp;}return 0;}// 判断两个单词是否只有对应一位不同public boolean oneWordDifferent(String beginWord, String curWord) {int c = 0, idx = 0;while (idx < beginWord.length()) {if (beginWord.charAt(idx) != curWord.charAt(idx))c++;idx++;}return c == 1;}
}

最佳:

class Solution {public int ladderLength(String beginWord, String endWord, List<String> wordList) {if (beginWord == null || endWord == null || wordList == null) {return 0;}// 将list转为set  查找速度转为O(1)Set<String> dict = new HashSet<>(wordList);if (!dict.contains(endWord)) {return 0;}Set<String> set1 = new HashSet<>();Set<String> set2 = new HashSet<>();set1.add(beginWord);set2.add(endWord);return bfs(set1, set2, dict, 1);}private int bfs(Set<String> set1, Set<String> set2, Set<String> dict, int len) {// 确保每次bfs都是对含元素少的set进行bfsif (set1.size() > set2.size()) {return bfs(set2, set1, dict, len);}Set<String> nextSet = new HashSet<>();for (String word : set1) {char[] chs = word.toCharArray();for (int i = 0; i < chs.length; i++) {char oldChar = chs[i];for (char c = 'a'; c <= 'z'; c++) {// 依次修改chs的每个位置上的字母(改为'a'-'z') 查看set2是否含有新单词if (c != oldChar) {chs[i] = c;}String newWord = new String(chs);if (set2.contains(newWord)) {return len + 1;}if (dict.contains(newWord)) {nextSet.add(newWord);dict.remove(newWord);}}chs[i] = oldChar; // 将chs[i]修改为原来的字母 下一步修改下一位置的字母}}// nextSet为空表明set1中所有元素都转不成dict中的字符串if (nextSet.isEmpty()) {return 0;}return bfs(nextSet, set2, dict, len + 1);}
}

结论:

看着大神写的代码,就是心旷神怡。(本菜鸡还是得多联系... 

 

 

这篇关于leetcode----127. Word Ladder的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/596406

相关文章

哈希leetcode-1

目录 1前言 2.例题  2.1两数之和 2.2判断是否互为字符重排 2.3存在重复元素1 2.4存在重复元素2 2.5字母异位词分组 1前言 哈希表主要是适合于快速查找某个元素(O(1)) 当我们要频繁的查找某个元素,第一哈希表O(1),第二,二分O(log n) 一般可以分为语言自带的容器哈希和用数组模拟的简易哈希。 最简单的比如数组模拟字符存储,只要开26个c

leetcode-24Swap Nodes in Pairs

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode swapPairs(L

leetcode-23Merge k Sorted Lists

带头结点。 /*** Definition for singly-linked list.* public class ListNode {* int val;* ListNode next;* ListNode(int x) { val = x; }* }*/public class Solution {public ListNode mergeKLists

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟)

【每日一题】LeetCode 2181.合并零之间的节点(链表、模拟) 题目描述 给定一个链表,链表中的每个节点代表一个整数。链表中的整数由 0 分隔开,表示不同的区间。链表的开始和结束节点的值都为 0。任务是将每两个相邻的 0 之间的所有节点合并成一个节点,新节点的值为原区间内所有节点值的和。合并后,需要移除所有的 0,并返回修改后的链表头节点。 思路分析 初始化:创建一个虚拟头节点

C语言 | Leetcode C语言题解之第393题UTF-8编码验证

题目: 题解: static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num & MASK1) == 0) {return

【JavaScript】LeetCode:16-20

文章目录 16 无重复字符的最长字串17 找到字符串中所有字母异位词18 和为K的子数组19 滑动窗口最大值20 最小覆盖字串 16 无重复字符的最长字串 滑动窗口 + 哈希表这里用哈希集合Set()实现。左指针i,右指针j,从头遍历数组,若j指针指向的元素不在set中,则加入该元素,否则更新结果res,删除集合中i指针指向的元素,进入下一轮循环。 /*** @param

C - Word Ladder题解

C - Word Ladder 题解 解题思路: 先输入两个字符串S 和t 然后在S和T中寻找有多少个字符不同的个数(也就是需要变换多少次) 开始替换时: tips: 字符串下标以0开始 我们定义两个变量a和b,用于记录当前遍历到的字符 首先是判断:如果这时a已经==b了,那么就跳过,不用管; 如果a大于b的话:那么我们就让s中的第i项替换成b,接着就直接输出S就行了。 这样

解决Office Word不能切换中文输入

我们在使用WORD的时可能会经常碰到WORD中无法输入中文的情况。因为,虽然我们安装了搜狗输入法,但是到我们在WORD中使用搜狗的输入法的切换中英文的按键的时候会发现根本没有效果,无法将输入法切换成中文的。下面我就介绍一下如何在WORD中把搜狗输入法切换到中文。

LeetCode:64. 最大正方形 动态规划 时间复杂度O(nm)

64. 最大正方形 题目链接 题目描述 给定一个由 0 和 1 组成的二维矩阵,找出只包含 1 的最大正方形,并返回其面积。 示例1: 输入: 1 0 1 0 01 0 1 1 11 1 1 1 11 0 0 1 0输出: 4 示例2: 输入: 0 1 1 0 01 1 1 1 11 1 1 1 11 1 1 1 1输出: 9 解题思路 这道题的思路是使用动态规划